#include <stdio.h>
#include "AVL.h"

//funo para criar/inicializar a AVL
void criar(AVL *A) {
     A->raiz=NULL;
}

//funo para finalizar a AVL; deve comear com p=raiz
void finalizar(no **p) {
     if (*p!=NULL) {
        finalizar(&(*p)->esq);
        finalizar(&(*p)->dir);
        free(*p);
     }
}

//imprime os elementos da rvore
void imprimir(no **p) {
     if (*p!=NULL) {
        printf("%d(",(*p)->info);
        imprimir(&(*p)->esq);
        printf(",");
        imprimir(&(*p)->dir);
        printf(")");
     }
     else printf("null");
}

//funo de busca de um elemento na AVL; deve comear com p=raiz
int buscar(no **p, int x) {
    if (*p==NULL)
       return 0;
    else if (x<(*p)->info)
         return(buscar(&(*p)->esq,x));
    else if (x>(*p)->info)
         return(buscar(&(*p)->dir,x));
    else return 1;
}

//funes para insero de um elemento na AVL
//a varivel "cresceu" indica se a rvore cresceu aps a insero
void EE(no **r) {
     no *b=*r;
     no *a=b->esq;
     b->esq=a->dir;
     a->dir=b;
     a->fb=0;
     b->fb=0;
     *r=a;
}

void DD(no **r) {
     no *a=*r;
     no *b=a->dir;
     a->dir=b->esq;
     b->esq=a;
     a->fb=0;
     b->fb=0;
     *r=b;
}

void ED(no **r) {
     no *c=*r;
     no *a=c->esq;
     no *b=a->dir;
     c->esq=b->dir;
     a->dir=b->esq;
     b->esq=a;
     b->dir=c;
     switch (b->fb) {
            case -1:
                 a->fb=0;
                 c->fb=1;
                 break;
            case 0:
                 a->fb=0;
                 c->fb=0;
                 break;
            case 1:
                 a->fb=-1;
                 c->fb=0;
                 break;
     }
     b->fb=0;
     *r=b;
}

void DE(no **r) {
     no *a=*r;
     no *c=a->dir;
     no *b=c->esq;
     c->esq=b->dir;
     a->dir=b->esq;
     b->esq=a;
     b->dir=c;
     switch (b->fb) {
            case -1:
                 a->fb=0;
                 c->fb=1;
                 break;
            case 0:
                 a->fb=0;
                 c->fb=0;
                 break;
            case 1:
                 a->fb=-1;
                 c->fb=0;
                 break;
     }
     b->fb=0;
     *r=b;
}

int aux_insere(no** p, int x, int *cresceu) {
    if (*p==NULL) {
       *p=(no*) malloc(sizeof(no));
       (*p)->info=x;
       (*p)->fb=0;
       (*p)->esq=NULL;
       (*p)->dir=NULL;
       *cresceu=1;
       return 1;
    }
    else if (x==(*p)->info)
         return 0;
    else if (x<(*p)->info) {
         if (aux_insere(&(*p)->esq,x,cresceu)) {
            if (*cresceu) {
	           switch ((*p)->fb) {
	                  case -1:
	                       if ((*p)->esq->fb==-1)
	                          EE(p);
                           else ED(p);
	                       *cresceu=0;
	                       break;
	                  case 0:
	                       (*p)->fb=-1;
	                       *cresceu=1;
	                       break;
                      case 1:
	                       (*p)->fb=0;
	                       *cresceu=0;
	                       break;
               }
            }
            return 1;
         }
         else return 0;
    }
    else {
         if (aux_insere(&(*p)->dir,x,cresceu)) {
            if (*cresceu) {
	           switch ((*p)->fb) {
	                  case -1:
	                       (*p)->fb=0;
                           *cresceu=0;
	                       break;
                      case 0:
	                       (*p)->fb=1;
	                       *cresceu=1;
	                       break;
                      case 1:
	                       if ((*p)->dir->fb==1)
	                          DD(p);
                           else DE(p);
	                       *cresceu=0;
	                       break;
               }
            }
            return 1;
         }
         else return 0;
    }
}

int inserir(no **p, int x) {
  int cresceu;
  return aux_insere(p, x, &cresceu);
}

int remover(no **p, int x) {
  int diminui;
  return aux_remover(p, x, &diminui);
}

//funo que retorna o maior elemento de uma subarvore com raiz em p
elem busca_menor(no *p) {
     while (p->esq!=NULL)
           p=p->esq;
     return (p->info);
}


//funo que remove um elemento de uma rvore
int aux_remover(no **p, int x, int *diminui) {
    no *aux;
    if (*p==NULL)
       return 0;
    else if (x<(*p)->info)
         {
               return(aux_remover(&(*p)->esq,x,diminui));

               if (*diminui) {
	           switch ((*p)->fb) {
	                  case -1:
	                       if ((*p)->esq->fb==-1)
	                          DD(p);
                           else DE(p);
	                       *diminui=0;
	                       break;
	                  case 0:
	                       (*p)->fb=-1;
	                       *diminui=1;
	                       break;
                      case 1:
	                       (*p)->fb=0;
	                       *diminui=0;
	                       break;
               }
            }
         }

    else if (x>(*p)->info)
        {
            return(aux_remover(&(*p)->dir,x,diminui));
            if (*diminui) {
	           switch ((*p)->fb) {
	                  case -1:
	                       (*p)->fb=0;
                           *diminui=0;
	                       break;
                      case 0:
	                       (*p)->fb=-1;//1
	                       *diminui=1;
	                       break;
                      case 1:
	                       if ((*p)->dir->fb==1)
	                          EE(p);
                           else ED(p);
	                       *diminui=0;
	                       break;
               }
            }

        }

             else {
         //caso 1: o n no tem filhos
         if (((*p)->esq==NULL) && ((*p)->dir==NULL)) {
            free(*p);
            *p=NULL;
            return 1;
         }
         //caso 2a: s h o filho direito
         else if ((*p)->esq==NULL) {
              aux=*p;
              *p=(*p)->dir;
              free(aux);
              return 1;
         }
         //caso 2b: s h o filho esquerdo
         else if ((*p)->dir==NULL) {
              aux=*p;
              *p=(*p)->esq;
              free(aux);
              return 1;
         }
         //caso 3: h os dois filhos
         else {
              (*p)->info=busca_menor((*p)->dir);
              return(aux_remover(&(*p)->dir,(*p)->info, diminui));
         }
    }
}
